import * as Electron from 'electron';

import { Type } from '@ucap/core';
import { AppConfiguration } from './models/app-configuration';

export abstract class Builder {
  static build<T>(
    appType: Type<T>,
    configuration: Partial<AppConfiguration>
  ): T {
    const app = new appType(configuration);

    return app;
  }
}
