import { Type, DecoratorUtil, Store } from '@ucap/core';

import { AutoUpdaterConfiguration } from '../models/auto-updater-configuration';

export const STORE_KEY_AUTO_UPDATER_SETTINGS =
  '@ucap::electron::auto-updater::auto-updater-settings';

export function AutoUpdaterSettings(
  configuration: Partial<AutoUpdaterConfiguration> = {}
  // tslint:disable-next-line: ban-types
): Function {
  return <T>(target: Type<any>): TypedPropertyDescriptor<T> | void => {
    switch (DecoratorUtil.getDecoratorType([target])) {
      case 'class':
        Store.setBy(STORE_KEY_AUTO_UPDATER_SETTINGS, configuration)(target);
        break;
    }
  };
}

export function getAppSettings(
  target: Type<any>,
  configuration: Partial<AutoUpdaterConfiguration> = {}
): AutoUpdaterConfiguration {
  const store = Store.from(target).get(STORE_KEY_AUTO_UPDATER_SETTINGS) || {};

  return {
    ...store,
    ...configuration
  };
}
