import * as Elctron from 'electron';

import { Type, DecoratorUtil, Store } from '@ucap/core';

import { BrowserWindowConfiguration } from '../models/browser-window-configuration';

export const STORE_KEY_BROWSER_WINDOW_SETTINGS =
  '@ucap::electron::browser-window::browser-window-settings';

export function BrowserWindowSettings(
  configuration: Partial<BrowserWindowConfiguration> = {}
  // tslint:disable-next-line: ban-types
): Function {
  return <T extends Elctron.BrowserWindow>(
    target: Type<T>
  ): TypedPropertyDescriptor<T> | void => {
    switch (DecoratorUtil.getDecoratorType([target])) {
      case 'class':
        Store.setBy(STORE_KEY_BROWSER_WINDOW_SETTINGS, configuration)(target);
        break;
    }
  };
}

export function getBrowserWindowSettings<T extends Elctron.BrowserWindow>(
  target: Type<T>
): BrowserWindowConfiguration {
  return Store.from(target).get(STORE_KEY_BROWSER_WINDOW_SETTINGS) || {};
}
