import * as Electron from 'electron';

import { Attacher as AppAttacher } from '../api/app/attacher';
import { Attacher as AutoUpdaterAttacher } from '../api/auto-updater/attacher';
import { Attacher as IpcMainAttacher } from '../api/ipc-main/attacher';

export abstract class Attacher {
  static attach(instance: any) {
    AppAttacher.attach(instance);
    AutoUpdaterAttacher.attach(instance);
    IpcMainAttacher.attach(instance);
  }

  static dettach(instance: any) {
    AppAttacher.dettach(instance);
    AutoUpdaterAttacher.dettach(instance);
    IpcMainAttacher.dettach(instance);
  }

  static dettachAll() {
    AppAttacher.dettachAll();
    AutoUpdaterAttacher.dettachAll();
    IpcMainAttacher.dettachAll();
  }
}
