import * as Electron from 'electron';
import { PlatformUtil } from './platform.util';

export class BrowserWindowUtil {
  static all(): Electron.BrowserWindow[] | undefined {
    if (PlatformUtil.isRenderer()) {
      return Electron.remote.BrowserWindow.getAllWindows();
    } else {
      return Electron.BrowserWindow.getAllWindows();
    }
  }

  static main(): Electron.BrowserWindow | undefined {
    const browserWindows: Electron.BrowserWindow[] = BrowserWindowUtil.all();

    if (!browserWindows || 0 === browserWindows.length) {
      return undefined;
    }

    return browserWindows[browserWindows.length - 1];
  }
}
